﻿Type=Class
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

#Event: Click
#DesignerProperty: Key: Rotation, DisplayName: Rotation, FieldType: String, DefaultValue: NONE, List: NONE|CLOCKWISE|ANTICLOCKWISE
Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Panel
	Private innerLabel As Label
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	
'	mBase.Initialize("")
	
End Sub

Public Sub DesignerCreateView (Base As Panel, lbl As Label, Props As Map)
	mBase = Base
	For Each key As String In Props.keys
		Select key
			Case "Rotation"
				Select Props.Get(key)
					Case "CLOCKWISE"
						RotateView(mBase, True)
					Case "ANTICLOCKWISE"
						RotateView(mBase, False)
					Case Else						
						
				End Select			
		End Select
	Next
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

'Adds the RotatedView onto the parent view which can be either an Activity or a Panel.
'Parent: Activity or a Panel
'Left, Top, Width, Height: Position and size of the RotatedView
Public Sub AddToParent(Parent As Activity, Left As Int, Top As Int, Width As Int, Height As Int)
	mBase.Initialize("")
	Parent.AddView(mBase, Left, Top, Width, Height)
End Sub

'Adds the RotatedView onto the parent view which can be either an Activity or a Panel.
'Parent: Activity or a Panel
'Left, Top, Width, Height: Position and size of the RotatedView
'Color: color of the background
'Rotaion: can bee "NONE", "CLOCKWISE", "ANTICLOCKWISE"
Public Sub AddToParent2(Parent As Activity, Left As Int, Top As Int, Width As Int, Height As Int, BackgroundColor As Int, Rotation As String)
	mBase.Initialize("")
	mBase.Color = BackgroundColor
	Parent.AddView(mBase, Left, Top, Width, Height)
	
	Dim Clockwise As Boolean
	Select Rotation
	Case "CLOCKWISE"
		RotateView(mBase, True)
	Case "ANTICLOCKWISE"
		RotateView(mBase, False)
	End Select
End Sub

Public Sub Rotate (clockwise As Boolean)
	RotateView(mBase, clockwise)
End Sub

Private Sub RotateView (vw As View, clockwise As Boolean)

	Dim centre_x As Float
	Dim centre_y As Float
	Dim height   As Int = vw.height

	Dim RotateDegrees As String
	
	If clockwise Then
		RotateDegrees = "90"
	Else
		RotateDegrees = "270"
	End If
	
' I commented these lines for testing, not sure if you really want this
'	centre_x  = vw.left + (vw.width/2)
'	centre_y  = vw.top  + (vw.height/2)
'	vw.top    = centre_y - (vw.width/2)
'	vw.left   = centre_x - (vw.height/2)		
'	vw.height = vw.Width
'	vw.width  = height

	Dim Reflect As Reflector
	Reflect.Target = vw
	Reflect.RunMethod2("setPivotX", vw.width/2, "java.lang.float")
	Reflect.RunMethod2("setPivotY", vw.height/2,"java.lang.float")
	Reflect.RunMethod2("setRotation", RotateDegrees, "java.lang.float")
End Sub